/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the Group type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Group{}

// Group struct for Group
type Group struct {
	GroupIdentifier               NullableString         `json:"groupIdentifier,omitempty"`
	DisplayName                   string                 `json:"displayName"`
	Description                   string                 `json:"description"`
	Public                        *bool                  `json:"public,omitempty"`
	EnforceMembershipRestrictions *bool                  `json:"enforceMembershipRestrictions,omitempty"`
	AdministratorsId              NullableString         `json:"administratorsId,omitempty"`
	ApprovalRequired              *bool                  `json:"approvalRequired,omitempty"`
	SelfSubscriptionType          *SelfSubscriptionType  `json:"selfSubscriptionType,omitempty"`
	PrivacyType                   *PrivacyType           `json:"privacyType,omitempty"`
	Dynamic                       *bool                  `json:"dynamic,omitempty"`
	DynamicGroupType              *DynamicGroupType      `json:"dynamicGroupType,omitempty"`
	Criteria                      map[string]interface{} `json:"criteria,omitempty"`
	Source                        NullableString         `json:"source,omitempty"`
	SyncType                      GroupSyncType          `json:"syncType"`
	SyncStatus                    GroupSyncStatus        `json:"syncStatus"`
	Gid                           NullableInt32          `json:"gid,omitempty"`
	IsComputingGroup              *bool                  `json:"isComputingGroup,omitempty"`
	RemoveNonActiveMembers        *bool                  `json:"removeNonActiveMembers,omitempty"`
	// Deprecated
	Topic                      NullableString    `json:"topic,omitempty"`
	MemberOfIdsRecursive       []string          `json:"memberOfIdsRecursive,omitempty"`
	MemberGroupIds             []string          `json:"memberGroupIds,omitempty"`
	MemberGroupIdsRecursive    []string          `json:"memberGroupIdsRecursive,omitempty"`
	MemberIdentityIds          []string          `json:"memberIdentityIds,omitempty"`
	MemberIdentityIdsRecursive []string          `json:"memberIdentityIdsRecursive,omitempty"`
	Owner                      *Identity         `json:"owner,omitempty"`
	AssignedScopes             []string          `json:"assignedScopes,omitempty"`
	GroupModeratorIds          []string          `json:"groupModeratorIds,omitempty"`
	ModeratedGroupIds          []string          `json:"moderatedGroupIds,omitempty"`
	ResourceCategory           *ResourceCategory `json:"resourceCategory,omitempty"`
	Reassignable               *bool             `json:"reassignable,omitempty"`
	AutoReassign               *bool             `json:"autoReassign,omitempty"`
	// Deprecated
	PendingAction    *bool          `json:"pendingAction,omitempty"`
	Disabled         *bool          `json:"disabled,omitempty"`
	Blocked          *bool          `json:"blocked,omitempty"`
	SecurityIssues   *bool          `json:"securityIssues,omitempty"`
	BlockingReason   NullableString `json:"blockingReason,omitempty"`
	BlockingTime     NullableTime   `json:"blockingTime,omitempty"`
	BlockingDeadline NullableTime   `json:"blockingDeadline,omitempty"`
	ArchiveDeadline  NullableTime   `json:"archiveDeadline,omitempty"`
	DeleteDeadline   NullableTime   `json:"deleteDeadline,omitempty"`
	// Deprecated
	ExpirationDeadline  NullableTime   `json:"expirationDeadline,omitempty"`
	OwnerId             NullableString `json:"ownerId,omitempty"`
	InternalState       *ResourceState `json:"internalState,omitempty"`
	State               *ResourceState `json:"state,omitempty"`
	LastStateChangeTime NullableTime   `json:"lastStateChangeTime,omitempty"`
	ValidityLimit       NullableTime   `json:"validityLimit,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _Group Group

// NewGroup instantiates a new Group object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroup(displayName string, description string, syncType GroupSyncType, syncStatus GroupSyncStatus) *Group {
	this := Group{}
	this.DisplayName = displayName
	this.Description = description
	this.SyncType = syncType
	this.SyncStatus = syncStatus
	return &this
}

// NewGroupWithDefaults instantiates a new Group object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupWithDefaults() *Group {
	this := Group{}
	return &this
}

// GetGroupIdentifier returns the GroupIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetGroupIdentifier() string {
	if o == nil || IsNil(o.GroupIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.GroupIdentifier.Get()
}

// GetGroupIdentifierOk returns a tuple with the GroupIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetGroupIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupIdentifier.Get(), o.GroupIdentifier.IsSet()
}

// HasGroupIdentifier returns a boolean if a field has been set.
func (o *Group) HasGroupIdentifier() bool {
	if o != nil && o.GroupIdentifier.IsSet() {
		return true
	}

	return false
}

// SetGroupIdentifier gets a reference to the given NullableString and assigns it to the GroupIdentifier field.
func (o *Group) SetGroupIdentifier(v string) {
	o.GroupIdentifier.Set(&v)
}

// SetGroupIdentifierNil sets the value for GroupIdentifier to be an explicit nil
func (o *Group) SetGroupIdentifierNil() {
	o.GroupIdentifier.Set(nil)
}

// UnsetGroupIdentifier ensures that no value is present for GroupIdentifier, not even an explicit nil
func (o *Group) UnsetGroupIdentifier() {
	o.GroupIdentifier.Unset()
}

// GetDisplayName returns the DisplayName field value
func (o *Group) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *Group) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *Group) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetDescription returns the Description field value
func (o *Group) GetDescription() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Description
}

// GetDescriptionOk returns a tuple with the Description field value
// and a boolean to check if the value has been set.
func (o *Group) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Description, true
}

// SetDescription sets field value
func (o *Group) SetDescription(v string) {
	o.Description = v
}

// GetPublic returns the Public field value if set, zero value otherwise.
func (o *Group) GetPublic() bool {
	if o == nil || IsNil(o.Public) {
		var ret bool
		return ret
	}
	return *o.Public
}

// GetPublicOk returns a tuple with the Public field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetPublicOk() (*bool, bool) {
	if o == nil || IsNil(o.Public) {
		return nil, false
	}
	return o.Public, true
}

// HasPublic returns a boolean if a field has been set.
func (o *Group) HasPublic() bool {
	if o != nil && !IsNil(o.Public) {
		return true
	}

	return false
}

// SetPublic gets a reference to the given bool and assigns it to the Public field.
func (o *Group) SetPublic(v bool) {
	o.Public = &v
}

// GetEnforceMembershipRestrictions returns the EnforceMembershipRestrictions field value if set, zero value otherwise.
func (o *Group) GetEnforceMembershipRestrictions() bool {
	if o == nil || IsNil(o.EnforceMembershipRestrictions) {
		var ret bool
		return ret
	}
	return *o.EnforceMembershipRestrictions
}

// GetEnforceMembershipRestrictionsOk returns a tuple with the EnforceMembershipRestrictions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetEnforceMembershipRestrictionsOk() (*bool, bool) {
	if o == nil || IsNil(o.EnforceMembershipRestrictions) {
		return nil, false
	}
	return o.EnforceMembershipRestrictions, true
}

// HasEnforceMembershipRestrictions returns a boolean if a field has been set.
func (o *Group) HasEnforceMembershipRestrictions() bool {
	if o != nil && !IsNil(o.EnforceMembershipRestrictions) {
		return true
	}

	return false
}

// SetEnforceMembershipRestrictions gets a reference to the given bool and assigns it to the EnforceMembershipRestrictions field.
func (o *Group) SetEnforceMembershipRestrictions(v bool) {
	o.EnforceMembershipRestrictions = &v
}

// GetAdministratorsId returns the AdministratorsId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetAdministratorsId() string {
	if o == nil || IsNil(o.AdministratorsId.Get()) {
		var ret string
		return ret
	}
	return *o.AdministratorsId.Get()
}

// GetAdministratorsIdOk returns a tuple with the AdministratorsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetAdministratorsIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AdministratorsId.Get(), o.AdministratorsId.IsSet()
}

// HasAdministratorsId returns a boolean if a field has been set.
func (o *Group) HasAdministratorsId() bool {
	if o != nil && o.AdministratorsId.IsSet() {
		return true
	}

	return false
}

// SetAdministratorsId gets a reference to the given NullableString and assigns it to the AdministratorsId field.
func (o *Group) SetAdministratorsId(v string) {
	o.AdministratorsId.Set(&v)
}

// SetAdministratorsIdNil sets the value for AdministratorsId to be an explicit nil
func (o *Group) SetAdministratorsIdNil() {
	o.AdministratorsId.Set(nil)
}

// UnsetAdministratorsId ensures that no value is present for AdministratorsId, not even an explicit nil
func (o *Group) UnsetAdministratorsId() {
	o.AdministratorsId.Unset()
}

// GetApprovalRequired returns the ApprovalRequired field value if set, zero value otherwise.
func (o *Group) GetApprovalRequired() bool {
	if o == nil || IsNil(o.ApprovalRequired) {
		var ret bool
		return ret
	}
	return *o.ApprovalRequired
}

// GetApprovalRequiredOk returns a tuple with the ApprovalRequired field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetApprovalRequiredOk() (*bool, bool) {
	if o == nil || IsNil(o.ApprovalRequired) {
		return nil, false
	}
	return o.ApprovalRequired, true
}

// HasApprovalRequired returns a boolean if a field has been set.
func (o *Group) HasApprovalRequired() bool {
	if o != nil && !IsNil(o.ApprovalRequired) {
		return true
	}

	return false
}

// SetApprovalRequired gets a reference to the given bool and assigns it to the ApprovalRequired field.
func (o *Group) SetApprovalRequired(v bool) {
	o.ApprovalRequired = &v
}

// GetSelfSubscriptionType returns the SelfSubscriptionType field value if set, zero value otherwise.
func (o *Group) GetSelfSubscriptionType() SelfSubscriptionType {
	if o == nil || IsNil(o.SelfSubscriptionType) {
		var ret SelfSubscriptionType
		return ret
	}
	return *o.SelfSubscriptionType
}

// GetSelfSubscriptionTypeOk returns a tuple with the SelfSubscriptionType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetSelfSubscriptionTypeOk() (*SelfSubscriptionType, bool) {
	if o == nil || IsNil(o.SelfSubscriptionType) {
		return nil, false
	}
	return o.SelfSubscriptionType, true
}

// HasSelfSubscriptionType returns a boolean if a field has been set.
func (o *Group) HasSelfSubscriptionType() bool {
	if o != nil && !IsNil(o.SelfSubscriptionType) {
		return true
	}

	return false
}

// SetSelfSubscriptionType gets a reference to the given SelfSubscriptionType and assigns it to the SelfSubscriptionType field.
func (o *Group) SetSelfSubscriptionType(v SelfSubscriptionType) {
	o.SelfSubscriptionType = &v
}

// GetPrivacyType returns the PrivacyType field value if set, zero value otherwise.
func (o *Group) GetPrivacyType() PrivacyType {
	if o == nil || IsNil(o.PrivacyType) {
		var ret PrivacyType
		return ret
	}
	return *o.PrivacyType
}

// GetPrivacyTypeOk returns a tuple with the PrivacyType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetPrivacyTypeOk() (*PrivacyType, bool) {
	if o == nil || IsNil(o.PrivacyType) {
		return nil, false
	}
	return o.PrivacyType, true
}

// HasPrivacyType returns a boolean if a field has been set.
func (o *Group) HasPrivacyType() bool {
	if o != nil && !IsNil(o.PrivacyType) {
		return true
	}

	return false
}

// SetPrivacyType gets a reference to the given PrivacyType and assigns it to the PrivacyType field.
func (o *Group) SetPrivacyType(v PrivacyType) {
	o.PrivacyType = &v
}

// GetDynamic returns the Dynamic field value if set, zero value otherwise.
func (o *Group) GetDynamic() bool {
	if o == nil || IsNil(o.Dynamic) {
		var ret bool
		return ret
	}
	return *o.Dynamic
}

// GetDynamicOk returns a tuple with the Dynamic field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetDynamicOk() (*bool, bool) {
	if o == nil || IsNil(o.Dynamic) {
		return nil, false
	}
	return o.Dynamic, true
}

// HasDynamic returns a boolean if a field has been set.
func (o *Group) HasDynamic() bool {
	if o != nil && !IsNil(o.Dynamic) {
		return true
	}

	return false
}

// SetDynamic gets a reference to the given bool and assigns it to the Dynamic field.
func (o *Group) SetDynamic(v bool) {
	o.Dynamic = &v
}

// GetDynamicGroupType returns the DynamicGroupType field value if set, zero value otherwise.
func (o *Group) GetDynamicGroupType() DynamicGroupType {
	if o == nil || IsNil(o.DynamicGroupType) {
		var ret DynamicGroupType
		return ret
	}
	return *o.DynamicGroupType
}

// GetDynamicGroupTypeOk returns a tuple with the DynamicGroupType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetDynamicGroupTypeOk() (*DynamicGroupType, bool) {
	if o == nil || IsNil(o.DynamicGroupType) {
		return nil, false
	}
	return o.DynamicGroupType, true
}

// HasDynamicGroupType returns a boolean if a field has been set.
func (o *Group) HasDynamicGroupType() bool {
	if o != nil && !IsNil(o.DynamicGroupType) {
		return true
	}

	return false
}

// SetDynamicGroupType gets a reference to the given DynamicGroupType and assigns it to the DynamicGroupType field.
func (o *Group) SetDynamicGroupType(v DynamicGroupType) {
	o.DynamicGroupType = &v
}

// GetCriteria returns the Criteria field value if set, zero value otherwise.
func (o *Group) GetCriteria() map[string]interface{} {
	if o == nil || IsNil(o.Criteria) {
		var ret map[string]interface{}
		return ret
	}
	return o.Criteria
}

// GetCriteriaOk returns a tuple with the Criteria field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetCriteriaOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Criteria) {
		return map[string]interface{}{}, false
	}
	return o.Criteria, true
}

// HasCriteria returns a boolean if a field has been set.
func (o *Group) HasCriteria() bool {
	if o != nil && !IsNil(o.Criteria) {
		return true
	}

	return false
}

// SetCriteria gets a reference to the given map[string]interface{} and assigns it to the Criteria field.
func (o *Group) SetCriteria(v map[string]interface{}) {
	o.Criteria = v
}

// GetSource returns the Source field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetSource() string {
	if o == nil || IsNil(o.Source.Get()) {
		var ret string
		return ret
	}
	return *o.Source.Get()
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Source.Get(), o.Source.IsSet()
}

// HasSource returns a boolean if a field has been set.
func (o *Group) HasSource() bool {
	if o != nil && o.Source.IsSet() {
		return true
	}

	return false
}

// SetSource gets a reference to the given NullableString and assigns it to the Source field.
func (o *Group) SetSource(v string) {
	o.Source.Set(&v)
}

// SetSourceNil sets the value for Source to be an explicit nil
func (o *Group) SetSourceNil() {
	o.Source.Set(nil)
}

// UnsetSource ensures that no value is present for Source, not even an explicit nil
func (o *Group) UnsetSource() {
	o.Source.Unset()
}

// GetSyncType returns the SyncType field value
func (o *Group) GetSyncType() GroupSyncType {
	if o == nil {
		var ret GroupSyncType
		return ret
	}

	return o.SyncType
}

// GetSyncTypeOk returns a tuple with the SyncType field value
// and a boolean to check if the value has been set.
func (o *Group) GetSyncTypeOk() (*GroupSyncType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SyncType, true
}

// SetSyncType sets field value
func (o *Group) SetSyncType(v GroupSyncType) {
	o.SyncType = v
}

// GetSyncStatus returns the SyncStatus field value
func (o *Group) GetSyncStatus() GroupSyncStatus {
	if o == nil {
		var ret GroupSyncStatus
		return ret
	}

	return o.SyncStatus
}

// GetSyncStatusOk returns a tuple with the SyncStatus field value
// and a boolean to check if the value has been set.
func (o *Group) GetSyncStatusOk() (*GroupSyncStatus, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SyncStatus, true
}

// SetSyncStatus sets field value
func (o *Group) SetSyncStatus(v GroupSyncStatus) {
	o.SyncStatus = v
}

// GetGid returns the Gid field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetGid() int32 {
	if o == nil || IsNil(o.Gid.Get()) {
		var ret int32
		return ret
	}
	return *o.Gid.Get()
}

// GetGidOk returns a tuple with the Gid field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetGidOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Gid.Get(), o.Gid.IsSet()
}

// HasGid returns a boolean if a field has been set.
func (o *Group) HasGid() bool {
	if o != nil && o.Gid.IsSet() {
		return true
	}

	return false
}

// SetGid gets a reference to the given NullableInt32 and assigns it to the Gid field.
func (o *Group) SetGid(v int32) {
	o.Gid.Set(&v)
}

// SetGidNil sets the value for Gid to be an explicit nil
func (o *Group) SetGidNil() {
	o.Gid.Set(nil)
}

// UnsetGid ensures that no value is present for Gid, not even an explicit nil
func (o *Group) UnsetGid() {
	o.Gid.Unset()
}

// GetIsComputingGroup returns the IsComputingGroup field value if set, zero value otherwise.
func (o *Group) GetIsComputingGroup() bool {
	if o == nil || IsNil(o.IsComputingGroup) {
		var ret bool
		return ret
	}
	return *o.IsComputingGroup
}

// GetIsComputingGroupOk returns a tuple with the IsComputingGroup field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetIsComputingGroupOk() (*bool, bool) {
	if o == nil || IsNil(o.IsComputingGroup) {
		return nil, false
	}
	return o.IsComputingGroup, true
}

// HasIsComputingGroup returns a boolean if a field has been set.
func (o *Group) HasIsComputingGroup() bool {
	if o != nil && !IsNil(o.IsComputingGroup) {
		return true
	}

	return false
}

// SetIsComputingGroup gets a reference to the given bool and assigns it to the IsComputingGroup field.
func (o *Group) SetIsComputingGroup(v bool) {
	o.IsComputingGroup = &v
}

// GetRemoveNonActiveMembers returns the RemoveNonActiveMembers field value if set, zero value otherwise.
func (o *Group) GetRemoveNonActiveMembers() bool {
	if o == nil || IsNil(o.RemoveNonActiveMembers) {
		var ret bool
		return ret
	}
	return *o.RemoveNonActiveMembers
}

// GetRemoveNonActiveMembersOk returns a tuple with the RemoveNonActiveMembers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetRemoveNonActiveMembersOk() (*bool, bool) {
	if o == nil || IsNil(o.RemoveNonActiveMembers) {
		return nil, false
	}
	return o.RemoveNonActiveMembers, true
}

// HasRemoveNonActiveMembers returns a boolean if a field has been set.
func (o *Group) HasRemoveNonActiveMembers() bool {
	if o != nil && !IsNil(o.RemoveNonActiveMembers) {
		return true
	}

	return false
}

// SetRemoveNonActiveMembers gets a reference to the given bool and assigns it to the RemoveNonActiveMembers field.
func (o *Group) SetRemoveNonActiveMembers(v bool) {
	o.RemoveNonActiveMembers = &v
}

// GetTopic returns the Topic field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *Group) GetTopic() string {
	if o == nil || IsNil(o.Topic.Get()) {
		var ret string
		return ret
	}
	return *o.Topic.Get()
}

// GetTopicOk returns a tuple with the Topic field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *Group) GetTopicOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Topic.Get(), o.Topic.IsSet()
}

// HasTopic returns a boolean if a field has been set.
func (o *Group) HasTopic() bool {
	if o != nil && o.Topic.IsSet() {
		return true
	}

	return false
}

// SetTopic gets a reference to the given NullableString and assigns it to the Topic field.
// Deprecated
func (o *Group) SetTopic(v string) {
	o.Topic.Set(&v)
}

// SetTopicNil sets the value for Topic to be an explicit nil
func (o *Group) SetTopicNil() {
	o.Topic.Set(nil)
}

// UnsetTopic ensures that no value is present for Topic, not even an explicit nil
func (o *Group) UnsetTopic() {
	o.Topic.Unset()
}

// GetMemberOfIdsRecursive returns the MemberOfIdsRecursive field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetMemberOfIdsRecursive() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MemberOfIdsRecursive
}

// GetMemberOfIdsRecursiveOk returns a tuple with the MemberOfIdsRecursive field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetMemberOfIdsRecursiveOk() ([]string, bool) {
	if o == nil || IsNil(o.MemberOfIdsRecursive) {
		return nil, false
	}
	return o.MemberOfIdsRecursive, true
}

// HasMemberOfIdsRecursive returns a boolean if a field has been set.
func (o *Group) HasMemberOfIdsRecursive() bool {
	if o != nil && !IsNil(o.MemberOfIdsRecursive) {
		return true
	}

	return false
}

// SetMemberOfIdsRecursive gets a reference to the given []string and assigns it to the MemberOfIdsRecursive field.
func (o *Group) SetMemberOfIdsRecursive(v []string) {
	o.MemberOfIdsRecursive = v
}

// GetMemberGroupIds returns the MemberGroupIds field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetMemberGroupIds() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MemberGroupIds
}

// GetMemberGroupIdsOk returns a tuple with the MemberGroupIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetMemberGroupIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.MemberGroupIds) {
		return nil, false
	}
	return o.MemberGroupIds, true
}

// HasMemberGroupIds returns a boolean if a field has been set.
func (o *Group) HasMemberGroupIds() bool {
	if o != nil && !IsNil(o.MemberGroupIds) {
		return true
	}

	return false
}

// SetMemberGroupIds gets a reference to the given []string and assigns it to the MemberGroupIds field.
func (o *Group) SetMemberGroupIds(v []string) {
	o.MemberGroupIds = v
}

// GetMemberGroupIdsRecursive returns the MemberGroupIdsRecursive field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetMemberGroupIdsRecursive() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MemberGroupIdsRecursive
}

// GetMemberGroupIdsRecursiveOk returns a tuple with the MemberGroupIdsRecursive field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetMemberGroupIdsRecursiveOk() ([]string, bool) {
	if o == nil || IsNil(o.MemberGroupIdsRecursive) {
		return nil, false
	}
	return o.MemberGroupIdsRecursive, true
}

// HasMemberGroupIdsRecursive returns a boolean if a field has been set.
func (o *Group) HasMemberGroupIdsRecursive() bool {
	if o != nil && !IsNil(o.MemberGroupIdsRecursive) {
		return true
	}

	return false
}

// SetMemberGroupIdsRecursive gets a reference to the given []string and assigns it to the MemberGroupIdsRecursive field.
func (o *Group) SetMemberGroupIdsRecursive(v []string) {
	o.MemberGroupIdsRecursive = v
}

// GetMemberIdentityIds returns the MemberIdentityIds field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetMemberIdentityIds() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MemberIdentityIds
}

// GetMemberIdentityIdsOk returns a tuple with the MemberIdentityIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetMemberIdentityIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.MemberIdentityIds) {
		return nil, false
	}
	return o.MemberIdentityIds, true
}

// HasMemberIdentityIds returns a boolean if a field has been set.
func (o *Group) HasMemberIdentityIds() bool {
	if o != nil && !IsNil(o.MemberIdentityIds) {
		return true
	}

	return false
}

// SetMemberIdentityIds gets a reference to the given []string and assigns it to the MemberIdentityIds field.
func (o *Group) SetMemberIdentityIds(v []string) {
	o.MemberIdentityIds = v
}

// GetMemberIdentityIdsRecursive returns the MemberIdentityIdsRecursive field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetMemberIdentityIdsRecursive() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MemberIdentityIdsRecursive
}

// GetMemberIdentityIdsRecursiveOk returns a tuple with the MemberIdentityIdsRecursive field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetMemberIdentityIdsRecursiveOk() ([]string, bool) {
	if o == nil || IsNil(o.MemberIdentityIdsRecursive) {
		return nil, false
	}
	return o.MemberIdentityIdsRecursive, true
}

// HasMemberIdentityIdsRecursive returns a boolean if a field has been set.
func (o *Group) HasMemberIdentityIdsRecursive() bool {
	if o != nil && !IsNil(o.MemberIdentityIdsRecursive) {
		return true
	}

	return false
}

// SetMemberIdentityIdsRecursive gets a reference to the given []string and assigns it to the MemberIdentityIdsRecursive field.
func (o *Group) SetMemberIdentityIdsRecursive(v []string) {
	o.MemberIdentityIdsRecursive = v
}

// GetOwner returns the Owner field value if set, zero value otherwise.
func (o *Group) GetOwner() Identity {
	if o == nil || IsNil(o.Owner) {
		var ret Identity
		return ret
	}
	return *o.Owner
}

// GetOwnerOk returns a tuple with the Owner field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetOwnerOk() (*Identity, bool) {
	if o == nil || IsNil(o.Owner) {
		return nil, false
	}
	return o.Owner, true
}

// HasOwner returns a boolean if a field has been set.
func (o *Group) HasOwner() bool {
	if o != nil && !IsNil(o.Owner) {
		return true
	}

	return false
}

// SetOwner gets a reference to the given Identity and assigns it to the Owner field.
func (o *Group) SetOwner(v Identity) {
	o.Owner = &v
}

// GetAssignedScopes returns the AssignedScopes field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetAssignedScopes() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.AssignedScopes
}

// GetAssignedScopesOk returns a tuple with the AssignedScopes field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetAssignedScopesOk() ([]string, bool) {
	if o == nil || IsNil(o.AssignedScopes) {
		return nil, false
	}
	return o.AssignedScopes, true
}

// HasAssignedScopes returns a boolean if a field has been set.
func (o *Group) HasAssignedScopes() bool {
	if o != nil && !IsNil(o.AssignedScopes) {
		return true
	}

	return false
}

// SetAssignedScopes gets a reference to the given []string and assigns it to the AssignedScopes field.
func (o *Group) SetAssignedScopes(v []string) {
	o.AssignedScopes = v
}

// GetGroupModeratorIds returns the GroupModeratorIds field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetGroupModeratorIds() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.GroupModeratorIds
}

// GetGroupModeratorIdsOk returns a tuple with the GroupModeratorIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetGroupModeratorIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.GroupModeratorIds) {
		return nil, false
	}
	return o.GroupModeratorIds, true
}

// HasGroupModeratorIds returns a boolean if a field has been set.
func (o *Group) HasGroupModeratorIds() bool {
	if o != nil && !IsNil(o.GroupModeratorIds) {
		return true
	}

	return false
}

// SetGroupModeratorIds gets a reference to the given []string and assigns it to the GroupModeratorIds field.
func (o *Group) SetGroupModeratorIds(v []string) {
	o.GroupModeratorIds = v
}

// GetModeratedGroupIds returns the ModeratedGroupIds field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetModeratedGroupIds() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.ModeratedGroupIds
}

// GetModeratedGroupIdsOk returns a tuple with the ModeratedGroupIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetModeratedGroupIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.ModeratedGroupIds) {
		return nil, false
	}
	return o.ModeratedGroupIds, true
}

// HasModeratedGroupIds returns a boolean if a field has been set.
func (o *Group) HasModeratedGroupIds() bool {
	if o != nil && !IsNil(o.ModeratedGroupIds) {
		return true
	}

	return false
}

// SetModeratedGroupIds gets a reference to the given []string and assigns it to the ModeratedGroupIds field.
func (o *Group) SetModeratedGroupIds(v []string) {
	o.ModeratedGroupIds = v
}

// GetResourceCategory returns the ResourceCategory field value if set, zero value otherwise.
func (o *Group) GetResourceCategory() ResourceCategory {
	if o == nil || IsNil(o.ResourceCategory) {
		var ret ResourceCategory
		return ret
	}
	return *o.ResourceCategory
}

// GetResourceCategoryOk returns a tuple with the ResourceCategory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetResourceCategoryOk() (*ResourceCategory, bool) {
	if o == nil || IsNil(o.ResourceCategory) {
		return nil, false
	}
	return o.ResourceCategory, true
}

// HasResourceCategory returns a boolean if a field has been set.
func (o *Group) HasResourceCategory() bool {
	if o != nil && !IsNil(o.ResourceCategory) {
		return true
	}

	return false
}

// SetResourceCategory gets a reference to the given ResourceCategory and assigns it to the ResourceCategory field.
func (o *Group) SetResourceCategory(v ResourceCategory) {
	o.ResourceCategory = &v
}

// GetReassignable returns the Reassignable field value if set, zero value otherwise.
func (o *Group) GetReassignable() bool {
	if o == nil || IsNil(o.Reassignable) {
		var ret bool
		return ret
	}
	return *o.Reassignable
}

// GetReassignableOk returns a tuple with the Reassignable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetReassignableOk() (*bool, bool) {
	if o == nil || IsNil(o.Reassignable) {
		return nil, false
	}
	return o.Reassignable, true
}

// HasReassignable returns a boolean if a field has been set.
func (o *Group) HasReassignable() bool {
	if o != nil && !IsNil(o.Reassignable) {
		return true
	}

	return false
}

// SetReassignable gets a reference to the given bool and assigns it to the Reassignable field.
func (o *Group) SetReassignable(v bool) {
	o.Reassignable = &v
}

// GetAutoReassign returns the AutoReassign field value if set, zero value otherwise.
func (o *Group) GetAutoReassign() bool {
	if o == nil || IsNil(o.AutoReassign) {
		var ret bool
		return ret
	}
	return *o.AutoReassign
}

// GetAutoReassignOk returns a tuple with the AutoReassign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetAutoReassignOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoReassign) {
		return nil, false
	}
	return o.AutoReassign, true
}

// HasAutoReassign returns a boolean if a field has been set.
func (o *Group) HasAutoReassign() bool {
	if o != nil && !IsNil(o.AutoReassign) {
		return true
	}

	return false
}

// SetAutoReassign gets a reference to the given bool and assigns it to the AutoReassign field.
func (o *Group) SetAutoReassign(v bool) {
	o.AutoReassign = &v
}

// GetPendingAction returns the PendingAction field value if set, zero value otherwise.
// Deprecated
func (o *Group) GetPendingAction() bool {
	if o == nil || IsNil(o.PendingAction) {
		var ret bool
		return ret
	}
	return *o.PendingAction
}

// GetPendingActionOk returns a tuple with the PendingAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *Group) GetPendingActionOk() (*bool, bool) {
	if o == nil || IsNil(o.PendingAction) {
		return nil, false
	}
	return o.PendingAction, true
}

// HasPendingAction returns a boolean if a field has been set.
func (o *Group) HasPendingAction() bool {
	if o != nil && !IsNil(o.PendingAction) {
		return true
	}

	return false
}

// SetPendingAction gets a reference to the given bool and assigns it to the PendingAction field.
// Deprecated
func (o *Group) SetPendingAction(v bool) {
	o.PendingAction = &v
}

// GetDisabled returns the Disabled field value if set, zero value otherwise.
func (o *Group) GetDisabled() bool {
	if o == nil || IsNil(o.Disabled) {
		var ret bool
		return ret
	}
	return *o.Disabled
}

// GetDisabledOk returns a tuple with the Disabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetDisabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Disabled) {
		return nil, false
	}
	return o.Disabled, true
}

// HasDisabled returns a boolean if a field has been set.
func (o *Group) HasDisabled() bool {
	if o != nil && !IsNil(o.Disabled) {
		return true
	}

	return false
}

// SetDisabled gets a reference to the given bool and assigns it to the Disabled field.
func (o *Group) SetDisabled(v bool) {
	o.Disabled = &v
}

// GetBlocked returns the Blocked field value if set, zero value otherwise.
func (o *Group) GetBlocked() bool {
	if o == nil || IsNil(o.Blocked) {
		var ret bool
		return ret
	}
	return *o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetBlockedOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocked) {
		return nil, false
	}
	return o.Blocked, true
}

// HasBlocked returns a boolean if a field has been set.
func (o *Group) HasBlocked() bool {
	if o != nil && !IsNil(o.Blocked) {
		return true
	}

	return false
}

// SetBlocked gets a reference to the given bool and assigns it to the Blocked field.
func (o *Group) SetBlocked(v bool) {
	o.Blocked = &v
}

// GetSecurityIssues returns the SecurityIssues field value if set, zero value otherwise.
func (o *Group) GetSecurityIssues() bool {
	if o == nil || IsNil(o.SecurityIssues) {
		var ret bool
		return ret
	}
	return *o.SecurityIssues
}

// GetSecurityIssuesOk returns a tuple with the SecurityIssues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetSecurityIssuesOk() (*bool, bool) {
	if o == nil || IsNil(o.SecurityIssues) {
		return nil, false
	}
	return o.SecurityIssues, true
}

// HasSecurityIssues returns a boolean if a field has been set.
func (o *Group) HasSecurityIssues() bool {
	if o != nil && !IsNil(o.SecurityIssues) {
		return true
	}

	return false
}

// SetSecurityIssues gets a reference to the given bool and assigns it to the SecurityIssues field.
func (o *Group) SetSecurityIssues(v bool) {
	o.SecurityIssues = &v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *Group) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *Group) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *Group) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *Group) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

// GetBlockingTime returns the BlockingTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetBlockingTime() time.Time {
	if o == nil || IsNil(o.BlockingTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingTime.Get()
}

// GetBlockingTimeOk returns a tuple with the BlockingTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetBlockingTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingTime.Get(), o.BlockingTime.IsSet()
}

// HasBlockingTime returns a boolean if a field has been set.
func (o *Group) HasBlockingTime() bool {
	if o != nil && o.BlockingTime.IsSet() {
		return true
	}

	return false
}

// SetBlockingTime gets a reference to the given NullableTime and assigns it to the BlockingTime field.
func (o *Group) SetBlockingTime(v time.Time) {
	o.BlockingTime.Set(&v)
}

// SetBlockingTimeNil sets the value for BlockingTime to be an explicit nil
func (o *Group) SetBlockingTimeNil() {
	o.BlockingTime.Set(nil)
}

// UnsetBlockingTime ensures that no value is present for BlockingTime, not even an explicit nil
func (o *Group) UnsetBlockingTime() {
	o.BlockingTime.Unset()
}

// GetBlockingDeadline returns the BlockingDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetBlockingDeadline() time.Time {
	if o == nil || IsNil(o.BlockingDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingDeadline.Get()
}

// GetBlockingDeadlineOk returns a tuple with the BlockingDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetBlockingDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingDeadline.Get(), o.BlockingDeadline.IsSet()
}

// HasBlockingDeadline returns a boolean if a field has been set.
func (o *Group) HasBlockingDeadline() bool {
	if o != nil && o.BlockingDeadline.IsSet() {
		return true
	}

	return false
}

// SetBlockingDeadline gets a reference to the given NullableTime and assigns it to the BlockingDeadline field.
func (o *Group) SetBlockingDeadline(v time.Time) {
	o.BlockingDeadline.Set(&v)
}

// SetBlockingDeadlineNil sets the value for BlockingDeadline to be an explicit nil
func (o *Group) SetBlockingDeadlineNil() {
	o.BlockingDeadline.Set(nil)
}

// UnsetBlockingDeadline ensures that no value is present for BlockingDeadline, not even an explicit nil
func (o *Group) UnsetBlockingDeadline() {
	o.BlockingDeadline.Unset()
}

// GetArchiveDeadline returns the ArchiveDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetArchiveDeadline() time.Time {
	if o == nil || IsNil(o.ArchiveDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ArchiveDeadline.Get()
}

// GetArchiveDeadlineOk returns a tuple with the ArchiveDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetArchiveDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveDeadline.Get(), o.ArchiveDeadline.IsSet()
}

// HasArchiveDeadline returns a boolean if a field has been set.
func (o *Group) HasArchiveDeadline() bool {
	if o != nil && o.ArchiveDeadline.IsSet() {
		return true
	}

	return false
}

// SetArchiveDeadline gets a reference to the given NullableTime and assigns it to the ArchiveDeadline field.
func (o *Group) SetArchiveDeadline(v time.Time) {
	o.ArchiveDeadline.Set(&v)
}

// SetArchiveDeadlineNil sets the value for ArchiveDeadline to be an explicit nil
func (o *Group) SetArchiveDeadlineNil() {
	o.ArchiveDeadline.Set(nil)
}

// UnsetArchiveDeadline ensures that no value is present for ArchiveDeadline, not even an explicit nil
func (o *Group) UnsetArchiveDeadline() {
	o.ArchiveDeadline.Unset()
}

// GetDeleteDeadline returns the DeleteDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetDeleteDeadline() time.Time {
	if o == nil || IsNil(o.DeleteDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.DeleteDeadline.Get()
}

// GetDeleteDeadlineOk returns a tuple with the DeleteDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetDeleteDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteDeadline.Get(), o.DeleteDeadline.IsSet()
}

// HasDeleteDeadline returns a boolean if a field has been set.
func (o *Group) HasDeleteDeadline() bool {
	if o != nil && o.DeleteDeadline.IsSet() {
		return true
	}

	return false
}

// SetDeleteDeadline gets a reference to the given NullableTime and assigns it to the DeleteDeadline field.
func (o *Group) SetDeleteDeadline(v time.Time) {
	o.DeleteDeadline.Set(&v)
}

// SetDeleteDeadlineNil sets the value for DeleteDeadline to be an explicit nil
func (o *Group) SetDeleteDeadlineNil() {
	o.DeleteDeadline.Set(nil)
}

// UnsetDeleteDeadline ensures that no value is present for DeleteDeadline, not even an explicit nil
func (o *Group) UnsetDeleteDeadline() {
	o.DeleteDeadline.Unset()
}

// GetExpirationDeadline returns the ExpirationDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *Group) GetExpirationDeadline() time.Time {
	if o == nil || IsNil(o.ExpirationDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationDeadline.Get()
}

// GetExpirationDeadlineOk returns a tuple with the ExpirationDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *Group) GetExpirationDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationDeadline.Get(), o.ExpirationDeadline.IsSet()
}

// HasExpirationDeadline returns a boolean if a field has been set.
func (o *Group) HasExpirationDeadline() bool {
	if o != nil && o.ExpirationDeadline.IsSet() {
		return true
	}

	return false
}

// SetExpirationDeadline gets a reference to the given NullableTime and assigns it to the ExpirationDeadline field.
// Deprecated
func (o *Group) SetExpirationDeadline(v time.Time) {
	o.ExpirationDeadline.Set(&v)
}

// SetExpirationDeadlineNil sets the value for ExpirationDeadline to be an explicit nil
func (o *Group) SetExpirationDeadlineNil() {
	o.ExpirationDeadline.Set(nil)
}

// UnsetExpirationDeadline ensures that no value is present for ExpirationDeadline, not even an explicit nil
func (o *Group) UnsetExpirationDeadline() {
	o.ExpirationDeadline.Unset()
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId.Get()) {
		var ret string
		return ret
	}
	return *o.OwnerId.Get()
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetOwnerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OwnerId.Get(), o.OwnerId.IsSet()
}

// HasOwnerId returns a boolean if a field has been set.
func (o *Group) HasOwnerId() bool {
	if o != nil && o.OwnerId.IsSet() {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given NullableString and assigns it to the OwnerId field.
func (o *Group) SetOwnerId(v string) {
	o.OwnerId.Set(&v)
}

// SetOwnerIdNil sets the value for OwnerId to be an explicit nil
func (o *Group) SetOwnerIdNil() {
	o.OwnerId.Set(nil)
}

// UnsetOwnerId ensures that no value is present for OwnerId, not even an explicit nil
func (o *Group) UnsetOwnerId() {
	o.OwnerId.Unset()
}

// GetInternalState returns the InternalState field value if set, zero value otherwise.
func (o *Group) GetInternalState() ResourceState {
	if o == nil || IsNil(o.InternalState) {
		var ret ResourceState
		return ret
	}
	return *o.InternalState
}

// GetInternalStateOk returns a tuple with the InternalState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetInternalStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InternalState) {
		return nil, false
	}
	return o.InternalState, true
}

// HasInternalState returns a boolean if a field has been set.
func (o *Group) HasInternalState() bool {
	if o != nil && !IsNil(o.InternalState) {
		return true
	}

	return false
}

// SetInternalState gets a reference to the given ResourceState and assigns it to the InternalState field.
func (o *Group) SetInternalState(v ResourceState) {
	o.InternalState = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *Group) GetState() ResourceState {
	if o == nil || IsNil(o.State) {
		var ret ResourceState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *Group) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given ResourceState and assigns it to the State field.
func (o *Group) SetState(v ResourceState) {
	o.State = &v
}

// GetLastStateChangeTime returns the LastStateChangeTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetLastStateChangeTime() time.Time {
	if o == nil || IsNil(o.LastStateChangeTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastStateChangeTime.Get()
}

// GetLastStateChangeTimeOk returns a tuple with the LastStateChangeTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetLastStateChangeTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastStateChangeTime.Get(), o.LastStateChangeTime.IsSet()
}

// HasLastStateChangeTime returns a boolean if a field has been set.
func (o *Group) HasLastStateChangeTime() bool {
	if o != nil && o.LastStateChangeTime.IsSet() {
		return true
	}

	return false
}

// SetLastStateChangeTime gets a reference to the given NullableTime and assigns it to the LastStateChangeTime field.
func (o *Group) SetLastStateChangeTime(v time.Time) {
	o.LastStateChangeTime.Set(&v)
}

// SetLastStateChangeTimeNil sets the value for LastStateChangeTime to be an explicit nil
func (o *Group) SetLastStateChangeTimeNil() {
	o.LastStateChangeTime.Set(nil)
}

// UnsetLastStateChangeTime ensures that no value is present for LastStateChangeTime, not even an explicit nil
func (o *Group) UnsetLastStateChangeTime() {
	o.LastStateChangeTime.Unset()
}

// GetValidityLimit returns the ValidityLimit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetValidityLimit() time.Time {
	if o == nil || IsNil(o.ValidityLimit.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ValidityLimit.Get()
}

// GetValidityLimitOk returns a tuple with the ValidityLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetValidityLimitOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidityLimit.Get(), o.ValidityLimit.IsSet()
}

// HasValidityLimit returns a boolean if a field has been set.
func (o *Group) HasValidityLimit() bool {
	if o != nil && o.ValidityLimit.IsSet() {
		return true
	}

	return false
}

// SetValidityLimit gets a reference to the given NullableTime and assigns it to the ValidityLimit field.
func (o *Group) SetValidityLimit(v time.Time) {
	o.ValidityLimit.Set(&v)
}

// SetValidityLimitNil sets the value for ValidityLimit to be an explicit nil
func (o *Group) SetValidityLimitNil() {
	o.ValidityLimit.Set(nil)
}

// UnsetValidityLimit ensures that no value is present for ValidityLimit, not even an explicit nil
func (o *Group) UnsetValidityLimit() {
	o.ValidityLimit.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Group) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Group) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Group) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Group) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Group) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Group) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Group) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Group) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Group) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Group) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Group) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Group) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.GroupIdentifier.IsSet() {
		toSerialize["groupIdentifier"] = o.GroupIdentifier.Get()
	}
	toSerialize["displayName"] = o.DisplayName
	toSerialize["description"] = o.Description
	if !IsNil(o.Public) {
		toSerialize["public"] = o.Public
	}
	if !IsNil(o.EnforceMembershipRestrictions) {
		toSerialize["enforceMembershipRestrictions"] = o.EnforceMembershipRestrictions
	}
	if o.AdministratorsId.IsSet() {
		toSerialize["administratorsId"] = o.AdministratorsId.Get()
	}
	if !IsNil(o.ApprovalRequired) {
		toSerialize["approvalRequired"] = o.ApprovalRequired
	}
	if !IsNil(o.SelfSubscriptionType) {
		toSerialize["selfSubscriptionType"] = o.SelfSubscriptionType
	}
	if !IsNil(o.PrivacyType) {
		toSerialize["privacyType"] = o.PrivacyType
	}
	if !IsNil(o.Dynamic) {
		toSerialize["dynamic"] = o.Dynamic
	}
	if !IsNil(o.DynamicGroupType) {
		toSerialize["dynamicGroupType"] = o.DynamicGroupType
	}
	if !IsNil(o.Criteria) {
		toSerialize["criteria"] = o.Criteria
	}
	if o.Source.IsSet() {
		toSerialize["source"] = o.Source.Get()
	}
	toSerialize["syncType"] = o.SyncType
	toSerialize["syncStatus"] = o.SyncStatus
	if o.Gid.IsSet() {
		toSerialize["gid"] = o.Gid.Get()
	}
	if !IsNil(o.IsComputingGroup) {
		toSerialize["isComputingGroup"] = o.IsComputingGroup
	}
	if !IsNil(o.RemoveNonActiveMembers) {
		toSerialize["removeNonActiveMembers"] = o.RemoveNonActiveMembers
	}
	if o.Topic.IsSet() {
		toSerialize["topic"] = o.Topic.Get()
	}
	if o.MemberOfIdsRecursive != nil {
		toSerialize["memberOfIdsRecursive"] = o.MemberOfIdsRecursive
	}
	if o.MemberGroupIds != nil {
		toSerialize["memberGroupIds"] = o.MemberGroupIds
	}
	if o.MemberGroupIdsRecursive != nil {
		toSerialize["memberGroupIdsRecursive"] = o.MemberGroupIdsRecursive
	}
	if o.MemberIdentityIds != nil {
		toSerialize["memberIdentityIds"] = o.MemberIdentityIds
	}
	if o.MemberIdentityIdsRecursive != nil {
		toSerialize["memberIdentityIdsRecursive"] = o.MemberIdentityIdsRecursive
	}
	if !IsNil(o.Owner) {
		toSerialize["owner"] = o.Owner
	}
	if o.AssignedScopes != nil {
		toSerialize["assignedScopes"] = o.AssignedScopes
	}
	if o.GroupModeratorIds != nil {
		toSerialize["groupModeratorIds"] = o.GroupModeratorIds
	}
	if o.ModeratedGroupIds != nil {
		toSerialize["moderatedGroupIds"] = o.ModeratedGroupIds
	}
	if !IsNil(o.ResourceCategory) {
		toSerialize["resourceCategory"] = o.ResourceCategory
	}
	if !IsNil(o.Reassignable) {
		toSerialize["reassignable"] = o.Reassignable
	}
	if !IsNil(o.AutoReassign) {
		toSerialize["autoReassign"] = o.AutoReassign
	}
	if !IsNil(o.PendingAction) {
		toSerialize["pendingAction"] = o.PendingAction
	}
	if !IsNil(o.Disabled) {
		toSerialize["disabled"] = o.Disabled
	}
	if !IsNil(o.Blocked) {
		toSerialize["blocked"] = o.Blocked
	}
	if !IsNil(o.SecurityIssues) {
		toSerialize["securityIssues"] = o.SecurityIssues
	}
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	if o.BlockingTime.IsSet() {
		toSerialize["blockingTime"] = o.BlockingTime.Get()
	}
	if o.BlockingDeadline.IsSet() {
		toSerialize["blockingDeadline"] = o.BlockingDeadline.Get()
	}
	if o.ArchiveDeadline.IsSet() {
		toSerialize["archiveDeadline"] = o.ArchiveDeadline.Get()
	}
	if o.DeleteDeadline.IsSet() {
		toSerialize["deleteDeadline"] = o.DeleteDeadline.Get()
	}
	if o.ExpirationDeadline.IsSet() {
		toSerialize["expirationDeadline"] = o.ExpirationDeadline.Get()
	}
	if o.OwnerId.IsSet() {
		toSerialize["ownerId"] = o.OwnerId.Get()
	}
	if !IsNil(o.InternalState) {
		toSerialize["internalState"] = o.InternalState
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if o.LastStateChangeTime.IsSet() {
		toSerialize["lastStateChangeTime"] = o.LastStateChangeTime.Get()
	}
	if o.ValidityLimit.IsSet() {
		toSerialize["validityLimit"] = o.ValidityLimit.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *Group) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"description",
		"syncType",
		"syncStatus",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varGroup := _Group{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varGroup)

	if err != nil {
		return err
	}

	*o = Group(varGroup)

	return err
}

type NullableGroup struct {
	value *Group
	isSet bool
}

func (v NullableGroup) Get() *Group {
	return v.value
}

func (v *NullableGroup) Set(val *Group) {
	v.value = val
	v.isSet = true
}

func (v NullableGroup) IsSet() bool {
	return v.isSet
}

func (v *NullableGroup) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroup(val *Group) *NullableGroup {
	return &NullableGroup{value: val, isSet: true}
}

func (v NullableGroup) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroup) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
